SystemOrganization addCategory: #'UCA_IS2-Stack-Tests'!
SystemOrganization addCategory: #'UCA_IS2-Stack'!

Object subclass: #Stacker
	instanceVariableNames: 'siguiente anterior tamao valor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA_IS2-Stack'!

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 21:44'!
elAnterior: previous
 anterior:= previous! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 21:42'!
elSiguiente: next
   siguiente:=next! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 20:03'!
isEmpty 
 ^(valor = nil) ! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 22:18'!
pop
| aux|
(siguiente =nil)
ifTrue: [(anterior=nil)
	ifTrue: [aux:=valor. valor:=nil. ^aux] ifFalse: [anterior elSiguiente:nil. aux:=valor. valor:=nil. ^aux]]
 ifFalse: [^(siguiente pop)]! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 22:03'!
push:value
   (valor=nil)
  ifTrue: [valor:=value] 
  ifFalse: [siguiente:=Stacker new.
	        siguiente elAnterior:self.
	        ^(siguiente push:value)]
	                                        ! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 22:37'!
size
  (siguiente =nil)
  ifTrue: [ (valor=nil) ifTrue: [^0] ifFalse:[^1] ] ifFalse: [^((siguiente size)+1)]! !

!Stacker methodsFor: 'as yet unclassified' stamp: 'gabrielcampagna 10/29/2012 19:59'!
top
  (siguiente =nil)
     ifTrue: [^valor]
     ifFalse: [^(siguiente top)]! !

TestCase subclass: #CollectionStackTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA_IS2-Stack-Tests'!

!CollectionStackTests methodsFor: 'examples' stamp: 'gabrielcampagna 10/29/2012 22:04'!
emptyStack

   ^(Stack new)! !

!CollectionStackTests methodsFor: 'examples' stamp: 'gabrielcampagna 10/29/2012 22:48'!
nonEmptyStack
  ^(Stack new
     add: 'No Vacio';
     yourself).! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:37'!
testEmptyError

	| aStack |
	
	aStack := self emptyStack.
	
	self should: [ aStack top ] raise: Error.
	self should: [ aStack pop] raise: Error.
	
	aStack push: 'element'.
	
	self shouldnt: [ aStack top ] raise: Error.
	self shouldnt: [ aStack pop] raise: Error.
	
	"The stack is empty again due to previous pop"
	self should: [ aStack top ] raise: Error.
	self should: [ aStack pop] raise: Error.! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:19'!
testIsEmpty

	self assert: (self emptyStack isEmpty).
	self deny: (self nonEmptyStack isEmpty).! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:37'!
testPop

	| aStack result element |

	element := 'anElement'.
	aStack := self emptyStack.
	
	aStack push: 'a'.
	aStack push: element.
	
	result := aStack pop.
	self assert: result = element.
	self assert: result == element.
	self assert: aStack size = 1.
	
	aStack pop.
	self assert: aStack isEmpty! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:20'!
testPush

	| aStack |

	aStack := self emptyStack.
	
	aStack push: 'a'.
	self assert: aStack size = 1.
	
	aStack push: 'b'.
	self assert: aStack size = 2! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:36'!
testSize
	
	| aStack |
	
	aStack := self emptyStack.
	
	self assert: aStack size = 0.
	
	aStack push: 'a'.
	self assert: aStack size = 1.
	
	aStack push: 'b'.
	self assert: aStack size = 2.
	
	aStack pop.
	self assert: aStack size = 1.
	
	aStack pop.
	self assert: aStack size = 0.

 
	


! !

!CollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:37'!
testTop

	| aStack |
	
	aStack := self emptyStack.

	self assert: aStack isEmpty.
	
	aStack push: 'a'.
	aStack push: 'b'.
	self assert: aStack top = 'b'.
	self assert: aStack top = 'b'.
	self assert: aStack size = 2.! !

TestCase subclass: #NonCollectionStackTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA_IS2-Stack-Tests'!

!NonCollectionStackTests methodsFor: 'examples' stamp: 'gabrielcampagna 10/29/2012 22:08'!
emptyStack

	^(Stacker new)
	! !

!NonCollectionStackTests methodsFor: 'examples' stamp: 'gabrielcampagna 10/29/2012 22:10'!
nonEmptyStack

	|unStacker|
	unStacker:= Stacker new.
	unStacker push: 'hola'.
	^unStacker! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testEmptyError

	| aStack |
	aStack := self emptyStack.
	self should: [ aStack top ] raise: Error.
	self should: [ aStack pop] raise: Error.
	
	aStack push: 'element'.
	
	self shouldnt: [ aStack top ] raise: Error.
	self shouldnt: [ aStack pop] raise: Error.
	
	"The stack is empty again due to previous pop"
	self should: [ aStack top ] raise: Error.
	self should: [ aStack pop] raise: Error.! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testIsEmpty

	self assert: (self emptyStack isEmpty).
	self deny: (self nonEmptyStack isEmpty).! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testPop

	| aStack res elem |

	elem := 'anElement'.
	aStack := self emptyStack.
	
	aStack push: 'a'.
	aStack push: elem.
	
	res := aStack pop.
	self assert: res = elem.
	self assert: res == elem.
	self assert: aStack size = 1.
	
	aStack pop.
	self assert: aStack isEmpty! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testPush

	| aStack |

	aStack := self emptyStack.
	
	aStack push: 'a'.
	self assert: aStack size = 1.
	
	aStack push: 'b'.
	self assert: aStack size = 2! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testSize
	
	| aStack |
	aStack := self emptyStack.
	
	self assert: aStack size = 0.
	
	aStack push: 'a'.
	self assert: aStack size = 1.
	
	aStack push: 'b'.
	self assert: aStack size = 2.
	
	aStack pop.
	self assert: aStack size = 1.
	
	aStack pop.
	self assert: aStack size = 0.

 
	


! !

!NonCollectionStackTests methodsFor: 'tests' stamp: 'jmaestri 10/16/2012 20:28'!
testTop

	| aStack |
	aStack := self emptyStack.

	self assert: aStack isEmpty.
	
	aStack push: 'a'.
	aStack push: 'b'.
	self assert: aStack top = 'b'.
	self assert: aStack top = 'b'.
	self assert: aStack size = 2.! !
